// Autogenerated from https://www.unicode.org/Public/15.0.0/ucd/

// `combiningClass` maps the code point to its combining class value.
pub fn combiningClass(cp: u21) u8 {
    return switch (cp) {
        0x334...0x338 => 1,
        0x1CD4 => 1,
        0x1CE2...0x1CE8 => 1,
        0x20D2...0x20D3 => 1,
        0x20D8...0x20DA => 1,
        0x20E5...0x20E6 => 1,
        0x20EA...0x20EB => 1,
        0x10A39 => 1,
        0x16AF0...0x16AF4 => 1,
        0x1BC9E => 1,
        0x1D167...0x1D169 => 1,
        0x16FF0...0x16FF1 => 6,
        0x93C => 7,
        0x9BC => 7,
        0xA3C => 7,
        0xABC => 7,
        0xB3C => 7,
        0xC3C => 7,
        0xCBC => 7,
        0x1037 => 7,
        0x1B34 => 7,
        0x1BE6 => 7,
        0x1C37 => 7,
        0xA9B3 => 7,
        0x110BA => 7,
        0x11173 => 7,
        0x111CA => 7,
        0x11236 => 7,
        0x112E9 => 7,
        0x1133B...0x1133C => 7,
        0x11446 => 7,
        0x114C3 => 7,
        0x115C0 => 7,
        0x116B7 => 7,
        0x1183A => 7,
        0x11943 => 7,
        0x11D42 => 7,
        0x1E94A => 7,
        0x3099...0x309A => 8,
        0x94D => 9,
        0x9CD => 9,
        0xA4D => 9,
        0xACD => 9,
        0xB4D => 9,
        0xBCD => 9,
        0xC4D => 9,
        0xCCD => 9,
        0xD3B...0xD3C => 9,
        0xD4D => 9,
        0xDCA => 9,
        0xE3A => 9,
        0xEBA => 9,
        0xF84 => 9,
        0x1039...0x103A => 9,
        0x1714 => 9,
        0x1715 => 9,
        0x1734 => 9,
        0x17D2 => 9,
        0x1A60 => 9,
        0x1B44 => 9,
        0x1BAA => 9,
        0x1BAB => 9,
        0x1BF2...0x1BF3 => 9,
        0x2D7F => 9,
        0xA806 => 9,
        0xA82C => 9,
        0xA8C4 => 9,
        0xA953 => 9,
        0xA9C0 => 9,
        0xAAF6 => 9,
        0xABED => 9,
        0x10A3F => 9,
        0x11046 => 9,
        0x11070 => 9,
        0x1107F => 9,
        0x110B9 => 9,
        0x11133...0x11134 => 9,
        0x111C0 => 9,
        0x11235 => 9,
        0x112EA => 9,
        0x1134D => 9,
        0x11442 => 9,
        0x114C2 => 9,
        0x115BF => 9,
        0x1163F => 9,
        0x116B6 => 9,
        0x1172B => 9,
        0x11839 => 9,
        0x1193D => 9,
        0x1193E => 9,
        0x119E0 => 9,
        0x11A34 => 9,
        0x11A47 => 9,
        0x11A99 => 9,
        0x11C3F => 9,
        0x11D44...0x11D45 => 9,
        0x11D97 => 9,
        0x11F41 => 9,
        0x11F42 => 9,
        0x5B0 => 10,
        0x5B1 => 11,
        0x5B2 => 12,
        0x5B3 => 13,
        0x5B4 => 14,
        0x5B5 => 15,
        0x5B6 => 16,
        0x5B7 => 17,
        0x5B8 => 18,
        0x5C7 => 18,
        0x5B9...0x5BA => 19,
        0x5BB => 20,
        0x5BC => 21,
        0x5BD => 22,
        0x5BF => 23,
        0x5C1 => 24,
        0x5C2 => 25,
        0xFB1E => 26,
        0x64B => 27,
        0x8F0 => 27,
        0x64C => 28,
        0x8F1 => 28,
        0x64D => 29,
        0x8F2 => 29,
        0x618 => 30,
        0x64E => 30,
        0x619 => 31,
        0x64F => 31,
        0x61A => 32,
        0x650 => 32,
        0x651 => 33,
        0x652 => 34,
        0x670 => 35,
        0x711 => 36,
        0xC55 => 84,
        0xC56 => 91,
        0xE38...0xE39 => 103,
        0xE48...0xE4B => 107,
        0xEB8...0xEB9 => 118,
        0xEC8...0xECB => 122,
        0xF71 => 129,
        0xF72 => 130,
        0xF7A...0xF7D => 130,
        0xF80 => 130,
        0xF74 => 132,
        0x321...0x322 => 202,
        0x327...0x328 => 202,
        0x1DD0 => 202,
        0x1DCE => 214,
        0x31B => 216,
        0xF39 => 216,
        0x1D165...0x1D166 => 216,
        0x1D16E...0x1D172 => 216,
        0x1DFA => 218,
        0x302A => 218,
        0x316...0x319 => 220,
        0x31C...0x320 => 220,
        0x323...0x326 => 220,
        0x329...0x333 => 220,
        0x339...0x33C => 220,
        0x347...0x349 => 220,
        0x34D...0x34E => 220,
        0x353...0x356 => 220,
        0x359...0x35A => 220,
        0x591 => 220,
        0x596 => 220,
        0x59B => 220,
        0x5A2...0x5A7 => 220,
        0x5AA => 220,
        0x5C5 => 220,
        0x655...0x656 => 220,
        0x65C => 220,
        0x65F => 220,
        0x6E3 => 220,
        0x6EA => 220,
        0x6ED => 220,
        0x731 => 220,
        0x734 => 220,
        0x737...0x739 => 220,
        0x73B...0x73C => 220,
        0x73E => 220,
        0x742 => 220,
        0x744 => 220,
        0x746 => 220,
        0x748 => 220,
        0x7F2 => 220,
        0x7FD => 220,
        0x859...0x85B => 220,
        0x899...0x89B => 220,
        0x8CF...0x8D3 => 220,
        0x8E3 => 220,
        0x8E6 => 220,
        0x8E9 => 220,
        0x8ED...0x8EF => 220,
        0x8F6 => 220,
        0x8F9...0x8FA => 220,
        0x952 => 220,
        0xF18...0xF19 => 220,
        0xF35 => 220,
        0xF37 => 220,
        0xFC6 => 220,
        0x108D => 220,
        0x193B => 220,
        0x1A18 => 220,
        0x1A7F => 220,
        0x1AB5...0x1ABA => 220,
        0x1ABD => 220,
        0x1ABF...0x1AC0 => 220,
        0x1AC3...0x1AC4 => 220,
        0x1ACA => 220,
        0x1B6C => 220,
        0x1CD5...0x1CD9 => 220,
        0x1CDC...0x1CDF => 220,
        0x1CED => 220,
        0x1DC2 => 220,
        0x1DCA => 220,
        0x1DCF => 220,
        0x1DF9 => 220,
        0x1DFD => 220,
        0x1DFF => 220,
        0x20E8 => 220,
        0x20EC...0x20EF => 220,
        0xA92B...0xA92D => 220,
        0xAAB4 => 220,
        0xFE27...0xFE2D => 220,
        0x101FD => 220,
        0x102E0 => 220,
        0x10A0D => 220,
        0x10A3A => 220,
        0x10AE6 => 220,
        0x10EFD...0x10EFF => 220,
        0x10F46...0x10F47 => 220,
        0x10F4B => 220,
        0x10F4D...0x10F50 => 220,
        0x10F83 => 220,
        0x10F85 => 220,
        0x1D17B...0x1D182 => 220,
        0x1D18A...0x1D18B => 220,
        0x1E4EE => 220,
        0x1E8D0...0x1E8D6 => 220,
        0x59A => 222,
        0x5AD => 222,
        0x1939 => 222,
        0x302D => 222,
        0x302E...0x302F => 224,
        0x1D16D => 226,
        0x5AE => 228,
        0x18A9 => 228,
        0x1DF7...0x1DF8 => 228,
        0x302B => 228,
        0x300...0x314 => 230,
        0x33D...0x344 => 230,
        0x346 => 230,
        0x34A...0x34C => 230,
        0x350...0x352 => 230,
        0x357 => 230,
        0x35B => 230,
        0x363...0x36F => 230,
        0x483...0x487 => 230,
        0x592...0x595 => 230,
        0x597...0x599 => 230,
        0x59C...0x5A1 => 230,
        0x5A8...0x5A9 => 230,
        0x5AB...0x5AC => 230,
        0x5AF => 230,
        0x5C4 => 230,
        0x610...0x617 => 230,
        0x653...0x654 => 230,
        0x657...0x65B => 230,
        0x65D...0x65E => 230,
        0x6D6...0x6DC => 230,
        0x6DF...0x6E2 => 230,
        0x6E4 => 230,
        0x6E7...0x6E8 => 230,
        0x6EB...0x6EC => 230,
        0x730 => 230,
        0x732...0x733 => 230,
        0x735...0x736 => 230,
        0x73A => 230,
        0x73D => 230,
        0x73F...0x741 => 230,
        0x743 => 230,
        0x745 => 230,
        0x747 => 230,
        0x749...0x74A => 230,
        0x7EB...0x7F1 => 230,
        0x7F3 => 230,
        0x816...0x819 => 230,
        0x81B...0x823 => 230,
        0x825...0x827 => 230,
        0x829...0x82D => 230,
        0x898 => 230,
        0x89C...0x89F => 230,
        0x8CA...0x8CE => 230,
        0x8D4...0x8E1 => 230,
        0x8E4...0x8E5 => 230,
        0x8E7...0x8E8 => 230,
        0x8EA...0x8EC => 230,
        0x8F3...0x8F5 => 230,
        0x8F7...0x8F8 => 230,
        0x8FB...0x8FF => 230,
        0x951 => 230,
        0x953...0x954 => 230,
        0x9FE => 230,
        0xF82...0xF83 => 230,
        0xF86...0xF87 => 230,
        0x135D...0x135F => 230,
        0x17DD => 230,
        0x193A => 230,
        0x1A17 => 230,
        0x1A75...0x1A7C => 230,
        0x1AB0...0x1AB4 => 230,
        0x1ABB...0x1ABC => 230,
        0x1AC1...0x1AC2 => 230,
        0x1AC5...0x1AC9 => 230,
        0x1ACB...0x1ACE => 230,
        0x1B6B => 230,
        0x1B6D...0x1B73 => 230,
        0x1CD0...0x1CD2 => 230,
        0x1CDA...0x1CDB => 230,
        0x1CE0 => 230,
        0x1CF4 => 230,
        0x1CF8...0x1CF9 => 230,
        0x1DC0...0x1DC1 => 230,
        0x1DC3...0x1DC9 => 230,
        0x1DCB...0x1DCC => 230,
        0x1DD1...0x1DF5 => 230,
        0x1DFB => 230,
        0x1DFE => 230,
        0x20D0...0x20D1 => 230,
        0x20D4...0x20D7 => 230,
        0x20DB...0x20DC => 230,
        0x20E1 => 230,
        0x20E7 => 230,
        0x20E9 => 230,
        0x20F0 => 230,
        0x2CEF...0x2CF1 => 230,
        0x2DE0...0x2DFF => 230,
        0xA66F => 230,
        0xA674...0xA67D => 230,
        0xA69E...0xA69F => 230,
        0xA6F0...0xA6F1 => 230,
        0xA8E0...0xA8F1 => 230,
        0xAAB0 => 230,
        0xAAB2...0xAAB3 => 230,
        0xAAB7...0xAAB8 => 230,
        0xAABE...0xAABF => 230,
        0xAAC1 => 230,
        0xFE20...0xFE26 => 230,
        0xFE2E...0xFE2F => 230,
        0x10376...0x1037A => 230,
        0x10A0F => 230,
        0x10A38 => 230,
        0x10AE5 => 230,
        0x10D24...0x10D27 => 230,
        0x10EAB...0x10EAC => 230,
        0x10F48...0x10F4A => 230,
        0x10F4C => 230,
        0x10F82 => 230,
        0x10F84 => 230,
        0x11100...0x11102 => 230,
        0x11366...0x1136C => 230,
        0x11370...0x11374 => 230,
        0x1145E => 230,
        0x16B30...0x16B36 => 230,
        0x1D185...0x1D189 => 230,
        0x1D1AA...0x1D1AD => 230,
        0x1D242...0x1D244 => 230,
        0x1E000...0x1E006 => 230,
        0x1E008...0x1E018 => 230,
        0x1E01B...0x1E021 => 230,
        0x1E023...0x1E024 => 230,
        0x1E026...0x1E02A => 230,
        0x1E08F => 230,
        0x1E130...0x1E136 => 230,
        0x1E2AE => 230,
        0x1E2EC...0x1E2EF => 230,
        0x1E4EF => 230,
        0x1E944...0x1E949 => 230,
        0x315 => 232,
        0x31A => 232,
        0x358 => 232,
        0x1DF6 => 232,
        0x302C => 232,
        0x1E4EC...0x1E4ED => 232,
        0x35C => 233,
        0x35F => 233,
        0x362 => 233,
        0x1DFC => 233,
        0x35D...0x35E => 234,
        0x360...0x361 => 234,
        0x1DCD => 234,
        0x345 => 240,
        else => 0,
    };
}
